//Dan collins
//3/27/2023

#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x23, 16, 2);

int motorPin = 5333; //pin to control two motors via transistor
int LEDpin = 9; // pin to control LED strip
int pumpPin = 2; //pin to control two motors via transistor

#define CLK 5 // Rotary Encoder Inputs
#define DT 8
#define SW 20
int newCLK; // used to determine direction of rotation of encoder
int oldCLK;

int listIndex = 1; // position in the list
int menu = -1; // what is being interacted with -1 is main menu, 0-2 are for changing settings
char *list[3] = {"Brightness   ","Pump speed  ","Motor speed  "};
int settings[3] = {5,0,0}; //brightness,wetness,fastness
bool motorState = 0;
bool buttonState = 0;

void setup() {
  lcd.init();
  lcd.clear();         
  lcd.backlight();
  pinMode(CLK,INPUT);
  pinMode(DT,INPUT);
  pinMode(SW, INPUT_PULLUP);

  pinMode(motorPin,OUTPUT);
  pinMode(LEDpin,OUTPUT);
}

void loop() {
  newCLK = digitalRead(CLK);
  if(newCLK != oldCLK  && newCLK == 1){ //the first time CLK is HIGH
    if (digitalRead(DT) != 1) { // if DT is aleady HIGH, then it's rotating CCW
      if(menu == -1){
        if(listIndex>0){
          listIndex--;
        }else{listIndex = 2;}
      }else{
        if(settings[menu] > 0){
          settings[menu] -= 5;
        }
      }
    } else {   // Encoder is rotating CW
      if(menu == -1){
        if(listIndex<2){
          listIndex++;
        }else{listIndex = 0;}
      }else{
        if(settings[menu] < 100){
          settings[menu] += 5;
        }
      }
    }
    if(menu == -1){
      for(int i = 0+listIndex; i < 2+listIndex; i++){ // prints out the menu differently depending on listIndex
        if(i==3){ // if it's at the end of the list
          lcd.setCursor(0,1);
          lcd.print(list[0]); // print the one at the begining
          lcd.print(settings[0]);
          lcd.print("%");
          break;
        }
        lcd.setCursor(0,i-listIndex);
        lcd.print(list[i]);
        lcd.print(settings[i]);
        lcd.print("%");
      }
    }else{
      lcd.setCursor(0,0);
      lcd.print(list[menu]); // print the one at the begining
      lcd.print(settings[menu]);
      lcd.print("%");
    }
  }
  analogWrite(motorPin,(settings[2]*(255/100)));
  analogWrite(LEDpin,(settings[0]*(255/100)));
  analogWrite(pumpPin,(settings[1]*(255/100)));
  if(digitalRead(SW) == LOW){ //
    if(!buttonState){
      buttonState=1;
      if(menu == -1){
        menu = listIndex;
      }else{
        menu = -1;
      }
    }
  }else{
    buttonState = 0;
  }
  oldCLK = newCLK;
  delay(1);
}
